/* Caprice32 - Amstrad CPC Emulator
   (c) Copyright 1997-2004 Ulrich Doewich

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

void draw8bpp_border_half(void)
{
   int colour;
   //register cpc_dword *mem_ptr;
   register  cpc_byte *mem_ptr;
 
   colour = GateArray.palette[16];
   //mem_ptr = CPC.scr_base + CPC.scr_offs; // PC screen buffer address
   mem_ptr = CPC.scr_base2 + (CPC.scr_offs*CPC.scr_line_offs); // PC screen buffer address

   *mem_ptr = (unsigned char) colour; // write four pixels of border colour
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (unsigned char) colour; // write four pixels of border colour
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (unsigned char) colour; // write four pixels of border colour
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (unsigned char) colour; // write four pixels of border colour
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (unsigned char) colour; // write four pixels of border colour
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (unsigned char) colour; // write four pixels of border colour
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (unsigned char) colour; // write four pixels of border colour
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (unsigned char) colour; // write four pixels of border colour
   
   CPC.scr_offs += 32; // update PC screen buffer address
}


void draw8bpp_border_half_NULL(void)
{
/*
   int colour;
   //register cpc_dword *mem_ptr;
   register  cpc_byte *mem_ptr;
 
   colour = GateArray.palette[16];
   //mem_ptr = CPC.scr_base + CPC.scr_offs; // PC screen buffer address
   mem_ptr = CPC.scr_base2 + (CPC.scr_offs*CPC.scr_line_offs); // PC screen buffer address

   *mem_ptr = (unsigned char) colour; // write four pixels of border colour
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (unsigned char) colour; // write four pixels of border colour
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (unsigned char) colour; // write four pixels of border colour
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (unsigned char) colour; // write four pixels of border colour
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (unsigned char) colour; // write four pixels of border colour
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (unsigned char) colour; // write four pixels of border colour
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (unsigned char) colour; // write four pixels of border colour
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (unsigned char) colour; // write four pixels of border colour
   
   */
   CPC.scr_offs += 32; // update PC screen buffer address
}

void draw8bpp_mode0_half(cpc_dword addr)
{
   cpc_byte idx, temp;
   //register cpc_dword *mem_ptr;
 register  cpc_byte *mem_ptr;
   //reg_pair val;

   //CPC.scr_offs/240
   //unsigned char n=0;
   
   mem_ptr = CPC.scr_base2 + (CPC.scr_offs*CPC.scr_line_offs); // PC screen buffer address
   idx = *(pbRAM + addr); // grab first CPC screen memory byte
	   
	   temp =  *mem_ptr = GateArray.palette[mode0_table[(idx<<1)]];
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
	   *mem_ptr = temp; //GateArray.palette[mode0_table[(idx*2)]];
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
	   temp = *mem_ptr = GateArray.palette[mode0_table[(idx<<1)+1]];
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
	   *mem_ptr = temp; //GateArray.palette[mode0_table[(idx*2)+1]];

   idx = *(pbRAM + ((addr+1)&0xffff)); // grab second CPC screen memory byte

   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
	   temp = *mem_ptr = GateArray.palette[mode0_table[(idx<<1)]];
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
	   *mem_ptr = temp;//GateArray.palette[mode0_table[(idx*2)]];
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
	   temp = *mem_ptr = GateArray.palette[mode0_table[(idx<<1)+1]];
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
	   *mem_ptr = temp;//GateArray.palette[mode0_table[(idx*2)+1]];

   CPC.scr_offs += 32; // update PC screen buffer address
}

void draw8bpp_mode1_half(cpc_dword addr)
{
   cpc_byte idx;
   register  cpc_byte *mem_ptr;
 
   mem_ptr = CPC.scr_base2 + (CPC.scr_offs*CPC.scr_line_offs); // PC screen buffer address
   idx = *(pbRAM + addr); // grab first CPC screen memory byte
   //idx=idx<<2; NO FUNKA :?
	   *mem_ptr = GateArray.palette[mode1_table[(idx<<2)+0]];
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
	   *mem_ptr = GateArray.palette[mode1_table[(idx<<2)+1]];
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
	   *mem_ptr = GateArray.palette[mode1_table[(idx<<2)+2]];
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
	   *mem_ptr = GateArray.palette[mode1_table[(idx<<2)+3]];
	   
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   idx = *(pbRAM + ((addr+1)&0xffff)); // grab second CPC screen memory byte
   
	   *mem_ptr = GateArray.palette[mode1_table[(idx<<2)+0]];
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
	   *mem_ptr = GateArray.palette[mode1_table[(idx<<2)+1]];
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
	   *mem_ptr = GateArray.palette[mode1_table[(idx<<2)+2]];
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
	   *mem_ptr = GateArray.palette[mode1_table[(idx<<2)+3]];

	   CPC.scr_offs += 32; // update PC screen buffer address
}


void draw8bpp_mode2_half(cpc_dword addr)
{
   cpc_byte pen_on, pen_off, pat;
   register  cpc_byte *mem_ptr;
   //reg_pair val;

   //CPC.scr_offs/240   
   mem_ptr = CPC.scr_base2 + (CPC.scr_offs*CPC.scr_line_offs); // PC screen buffer address
   
	pen_on = GateArray.palette[1];
	pen_off = GateArray.palette[0];

   //idx = *(pbRAM + addr); // grab first CPC screen memory byte

   pat = *(pbRAM + addr); // grab first CPC screen memory byte
   *mem_ptr = (pat & 0x80) ? pen_on : pen_off;
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (pat & 0x20) ? pen_on : pen_off;
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (pat & 0x08) ? pen_on : pen_off;
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (pat & 0x02) ? pen_on : pen_off;
   
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   pat = *(pbRAM + ((addr+1)&0xffff)); // grab second CPC screen memory byte
   
   *mem_ptr = (pat & 0x80) ? pen_on : pen_off;
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (pat & 0x20) ? pen_on : pen_off;
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (pat & 0x08) ? pen_on : pen_off;
   mem_ptr+=CPC_VISIBLE_SCR_HEIGHT;
   *mem_ptr = (pat & 0x02) ? pen_on : pen_off;
      
   CPC.scr_offs += 32; // update PC screen buffer address
}


