/*! \file interface.h
 *  \brief Interfaces publicos de la libreria de la Gui.
 *         Libreria de Dingoo.
 *
 *  \version 0.9
 *
 *  Dingoo Interface driver
 *
 *   Pituka - Dingoo Port
 *  (c) Copyright 2009 David Colmenero (aka D_Skywalk)
 */

#ifndef motewii_h
#define motewii_h

int InitGFX (void);
void FreeGFX (void);

void ShowSplash (void);
void ShowKeyboard (void);
void ShowLed (void);

void Keyboard_getControl (void);

#endif
